﻿//Main code starts here
FahrenheitToCelsius x = new(-50);   //Create object x. This calls the constructor which,
                                    //in turn, calls the setter.

Console.WriteLine(x.Temperature);   //This calls the getter.

x.Temperature = -65;                //This calls the setter
Console.WriteLine(x.Temperature);   //This calls the getter

x.Temperature = -500;               //This calls the setter and throws an error
Console.WriteLine(x.Temperature);

//Define the class
class FahrenheitToCelsius {
  private double _temperature;    //This defines a private field

  //Define the constructor
  public FahrenheitToCelsius(double value) { 
    this.Temperature = value;  //Property is initialized. This calls the setter
  }

  //Define a public property
  public double Temperature {
    //Define the getter
    get {
      return 5.0 / 9.0 * (this._temperature - 32.0);
    }

    //Define the setter
    set {
      if (value >= -459.67) {
        this._temperature = value;
      }
      else {
        throw new Exception("There is no temperature below -459.67");
      }
    }
  }
}
